import os
import logging

import torch.distributed as dist


class FilterMainRankOnly(logging.Filter):
    def filter(self, record):
        if not dist.is_available():
            return True
        if not dist.is_initialized():
            return True
        return dist.get_rank() == 0
